//INTERFACCIA CLIENTE
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.lang.*;
import javax.swing.table.*;
import java.io.*;
import java.net.Socket;

import java.net.DatagramSocket;
import java.net.DatagramPacket;
import java.net.SocketException;
import java.net.InetAddress;
import java.net.UnknownHostException;


/****************************************************************************
**
**     Classe CLIENTE, interfaccia Grafica e gestore del Cliente, 
**     con Server prioritario deciso all'Avvio
**
****************************************************************************/

public class Cliente extends JFrame{
        public static int LARGHEZZA=700;
        public static int ALTEZZA=600;
        public static String TITOLO="Postazione CLIENTE";
        public static int modalita = 1; //mod.  0 - STATICA
                                        //      1 - DINAMICA
        static protected String address[]=new String[2];  // indirizzi SERVER
        public Socket socketSERVER;
        ObjectOutputStream outStream;
        ObjectInputStream StreamIn;

        
        MESSAGGIO dialogErrore;
        ErroriHandler eh=new ErroriHandler();


	 
	Container frameContainer;
	
	//COMPONENTI SWING
        JPanel     panel     =  new JPanel();


        CalendarModel model = new CalendarModel();
        JTable table = new JTable(model);


        JButton Brichiedi    =  new JButton("Aggiorna Situazione");
        JButton Bprenota     =  new JButton("Prenotazione");

        JCheckBox[] n = new JCheckBox[48];

        JTextField nome = new JTextField();

	//COSTRUTTORE
        public Cliente(int priority) throws ClassNotFoundException{

		super(TITOLO);

                //inizializzazione tabella indirizzi
                if (priority == 1){
                      address[0]="lab2-pc02"; //Server1
                      address[1]="lab2-pc05"; //Server2 
                      }
                else {
                      address[0]="lab2-pc05"; //Server2
                      address[1]="lab2-pc02"; //Server1 
                     }

		buildGUI();
		setupEventHandlers();
		setSize(LARGHEZZA,ALTEZZA);
		show();
                //viene creata,stat. o dinam. una connessione ad un Server
                creaconnessione();
	}

        //CREAZIONE CONNESSIONE
        void creaconnessione() throws ClassNotFoundException{
           int porta = 0;              //definisce la porta di comunicazione
           String indSERVER = "NACK";  //definisce l'indirizzo del SERVER

           if (modalita == 1){
                indSERVER = toMANAGER();                              // provo a connettermi
                if (indSERVER.equalsIgnoreCase("NACK")) modalita = 0; // se il manager non risponde
                                                                      // vado in mod. statica
                if (indSERVER.equalsIgnoreCase("NOSERVER")){
                        System.out.println("Il Manager  up ma non ci sono ancora Server attivi.");
                        System.out.println("Attendere e riprovare.");
                        System.exit(1);
                       }


                }
           if (modalita==0) indSERVER=getStaticPrimarySer();
           if (indSERVER.equals("lab2-pc02")) porta = 54; else porta =542; // (1100 - 1200)
           System.out.println("indSERVER: "+indSERVER+" MOD.: "+modalita+" porta: "+porta);
           //if ((indSERVER.equals("lab2-pc04")) || (indSERVER.equals("lab2-pc03"))) indSERVER="oemcomputer";
           // in entrambe le modalita ho indSERVER e posso connettermi
           Connessione Conn = toSERVER(indSERVER,porta);
           if (Conn.valido == true) {
                                     socketSERVER = Conn.socket;
                                     System.out.println("Connected to "+indSERVER);
                                    }
             else if (modalita==0){System.out.println("Non sono riuscito a stabilire la connessione con il Server di default.");
                                   System.out.println("Provo a connettermi con l'altro..."); 
                                   indSERVER=getStaticSecondarySer();
                                   if (indSERVER.equals("lab2-pc02")) porta = 54; else porta =542; // (1100 - 1200)
                                   System.out.println("indSERVER: "+indSERVER+" MOD.: "+modalita+" porta: "+porta);
                                   Conn = toSERVER(indSERVER,porta);
                                   if (Conn.valido == true){
                                             socketSERVER = Conn.socket;
                                             System.out.println("Connected to "+indSERVER);
                                             }
                                   else{System.out.println("Server entrambi spenti.");
                                   System.exit(1);                    
                                   }
                   }else {System.out.println("Il server  caduto.Riprovare");                          
                          System.exit(1); 
                          }
                    
          try{
          // CREO STREAM
          outStream = new ObjectOutputStream(socketSERVER.getOutputStream());
          StreamIn = new ObjectInputStream(socketSERVER.getInputStream());

          // MANDO RICHIESTA
          String richiesta = new String("Richiesta");
          outStream.writeObject(richiesta);
          outStream.flush();
          System.out.println("Inviata Richiesta al Server");

          // LEGGO LA RISPOSTA DAL SERVER e AGGIORNO TABELLA
          leggiDalServer();
          }catch (IOException ex){
             System.out.println("Cliente: IOException ");
             System.exit(1);
             }

          }

        public boolean mandaAlServer(String s){
             try{
                 outStream.writeObject(s);
                 outStream.flush();
                }catch (IOException ex){
                  System.out.println("IO error in invio al Server in Cliente.mandaAlServer().");
                  return false;
                  }
             return true;
             }


        //  LETTURA e INVIO DI UNA TABELLA DI PRENOTAZIONE AL SERVER
        public boolean mandaDBAlServer(){
              DB pren = new DB();           // Prenotazione da effettuare
              String name = nome.getText(); // Nome del prenotante
              for (int i=0;i<48;i++)
                if (n[i].isSelected()) {
                                        int riga = i / 6;
                                        int col  = i % 6;
                                        if (!(pren.inseriscipren(riga+1,col+1,name))) System.out.println("Errore nel creare localmente la tabella");
                                       }
                try{
                 outStream.writeObject(pren);
                 outStream.flush();
                 }catch (IOException ex){
                  System.out.println("IO error in invio al Server in Cliente.mandaDBAlServer().");
                  return false;
                  }
              return true;
              }




        // LETTURA DI UN OGGETTO INVIATO DAL SERVER
        public boolean leggiDalServer(){
          DB     inputDB;

          try{
           try{


          // LEGGO
          Object input = StreamIn.readObject();

          // SE RICEVO UNA STRINGA:ERRORE!
          if (input instanceof String){
             System.out.println("Letto: "+input);
             String testo[]   = {(String) input," "};
             String bottoni[] = {"OK"};
             dialogErrore=new MESSAGGIO(Cliente.this,"Inpossibile Prenotare",true,testo,bottoni,eh,eh);
             dialogErrore.setLocation(150,150);
             dialogErrore.show();

             }

          // SE RICEVO UN DB AGGIORNO LA TABELLA
          if (input instanceof DB){ 
                    inputDB = (DB) input;
                    System.out.println("Ricevuto.Input: "+input);
                    System.out.println("Ricevuto.NEW TABLE: "+inputDB);
                    for(int i=0;i<8;++i)
                      for(int j=0;j<6;++j)
                        table.setValueAt(inputDB.leggipren(i+1,j+1),i,j);
                    table.updateUI();
                    table.repaint();
                    }
        
         return true;
          }catch (IOException ex){
             System.out.println("Il Server  caduto:Riconnettersi");
             System.exit(1);
             return false;
             }
          }catch (ClassNotFoundException cnfe){
             System.out.println("C.N.F.E. error in Cliente.leggiDalServer(). Classe dell'oggetto letto sconosciuta.");
             return false;
             }

          }



	//IMPOSTAZIONE MENU E LAYOUT
	void buildGUI(){
		setupButtonPanel();
		layoutComponents();
	}
		
	//MENU
	
	//BOTTONI
	void setupButtonPanel(){
		panel.setLayout(null);
		
		Intestazione in= new Intestazione();
                in.setBounds(10,5,500,60);
		panel.add(in);
		
		Intestazione1 in1 = new Intestazione1();
                in1.setBounds(50,80,550,40);
		panel.add(in1);

                Intestazione2 in2 = new Intestazione2();
                in2.setBounds(10,300,590,30);
                panel.add(in2);

                Intestazione3 in3 = new Intestazione3();
                in3.setBounds(30,336,300,30);
                panel.add(in3);

                IntestazioneNome in4 = new IntestazioneNome();
                in4.setBounds(350,350,100,30);
                panel.add(in4);

                nome.setBackground(Color.white);
                nome.setBounds(360,390,100,30);
                panel.add(nome);



                Orari orariosit = new Orari();
                orariosit.setBounds(5,105,90,137);
                panel.add(orariosit);

                Orari2 orariopre = new Orari2();
                orariopre.setBounds(5,360,110,200);
                panel.add(orariopre);


                // CREAZIONE ChecKBox PRENOTAZIONI
		int k=0;
		int l=0;
		int j=0;
                for(int i=0;i<48;i++){
                        if(j==6){j=0;k=0;l=l+20;}
                        n[i]=new JCheckBox();
                  n[i].setBounds(100+k,360+l,15,15);
                  n[i].setBackground(Color.white);
		  panel.add(n[i]);
		  j=j+1;
                  k=k+30;
                 
		}



                Brichiedi.setBackground(Color.red);
                Brichiedi.setBounds(465,252,185,48);
                Brichiedi.setToolTipText("Aggiorna la situazione");
                panel.add(Brichiedi);
		
                Bprenota.setBackground(Color.red);
                Bprenota.setBounds(465,465,185,48);
                Bprenota.setToolTipText("Esegue la prenotazione");
                panel.add(Bprenota);

                table.setBounds(100,105,550,137);
                table.setBackground(Color.green);
                table.setGridColor(Color.black);
                table.setShowGrid(true);
                panel.add(table);
		
		
	}
	
	//LAYOUT
	public void layoutComponents(){
                frameContainer = getContentPane();
		frameContainer.setLayout(new BorderLayout());
		frameContainer.add("Center",panel);
		panel.setBorder(new EtchedBorder()); //definizione del tipo di bordo del pannello
		
	}
	
	//REGISTRAZIONE DEGLI EVENTI
	void setupEventHandlers(){
                addWindowListener(new WindowHandlerCliente());
                Bprenota.addActionListener(new MenuItemHandlerCliente());
                Brichiedi.addActionListener(new MenuItemHandlerCliente());

	}

        public String getStaticPrimarySer(){
        return address[0];                      
        }

        public String getStaticSecondarySer(){
        return address[1];
        }


        // PER TENTATIVO DI CONNESSIONE AL MANAGER
        // ED ACQUISIZIONE INDIRIZZO SERVER IN MOD.DINAMICA

        public String toMANAGER(){
           DatagramSocket socketMANAGER;
           int bufferLength = 256;
           byte outBuffer[];
           byte inBuffer[];
           DatagramPacket outDatagram;
           DatagramPacket inDatagram;
           String indSERVER = "";
           String data =new String("NACK");  //Valore di ritorno

           try{
             try{
                socketMANAGER = new DatagramSocket();
                inBuffer  = new byte[bufferLength];
                outBuffer = new byte[bufferLength];
                InetAddress destManagerAddress  = InetAddress.getByName("lab2-pc04");
                String destManagerHost = destManagerAddress.getHostName().trim();
                //InetAddress localAddress = InetAddress.getLocalHost();
                //InetAddress destAddress  = InetAddress.getByName("lab2-pc04");
                //String destHost = destAddress.getHostName().trim();
                //String localHost = localAddress.getHostName();
                //System.out.println("LocalAddress: "+localAddress);
                outBuffer = new byte[bufferLength];
                outBuffer = "getconn".getBytes();
                outDatagram = new DatagramPacket(outBuffer,outBuffer.length,destManagerAddress,2345);
                socketMANAGER.send(outDatagram);
                System.out.println("\nSent 'getconn' to "+destManagerHost+" at port 2345.");
                inDatagram = new DatagramPacket(inBuffer,inBuffer.length);
                socketMANAGER.setSoTimeout(4000);
                socketMANAGER.receive(inDatagram);
                destManagerAddress = inDatagram.getAddress();
                destManagerHost = destManagerAddress.getHostName().trim();
                int destPort = inDatagram.getPort();
                System.out.println("Received a datagram from "+destManagerHost+" at port "+destPort+".");
                data = new String(inDatagram.getData());
                data=data.trim();
                System.out.println("It contained the following data: "+data);

             }catch(SocketException es){
                System.out.println("TIME-OUT scaduto!");
                System.out.println("Il Manager non risponde, mi accingo a  lavorare in mod. STATICA.");
                }

           }catch (IOException ex){
             System.out.println("Il Manager non risponde, mi accingo a  lavorare in mod. STATICA.");
             }
           return data;
           }


           // CONNESSIONE AL SERVER
           public Connessione toSERVER(String destServer,int port)throws ClassNotFoundException{
           Socket socketSERVER;
           int porta = port;
           InetAddress IPServer;
           Connessione conn =new Connessione();  //Valore di ritorno

           try{
             InetAddress localAddress = InetAddress.getLocalHost();
             System.out.println("Provo a connettermi con "+destServer);

             try{
               IPServer = InetAddress.getByName(destServer);
               socketSERVER = new Socket(IPServer,porta);
               System.out.println("Connected to: "+IPServer+" on port: "+porta);
               conn = new Connessione(socketSERVER);
               }catch (IOException ex){
                  System.out.println("IO error creating socket in Cliente.toSERVER(destServer,int)");
                  }


           }catch (UnknownHostException ex){
              System.out.println("Cliente.toServer:Unknown host");
              System.exit(1);
              }
           return conn;
           }


        // MAIN
        public static void main(String[] args) throws ClassNotFoundException{
               int prior = 0;
               if (args.length!=1) {
                                     System.out.println("Uso: java Cliente prior [1-prior.to Master,2 - to Slave]");
                                     System.exit(0);
                                    }
               try{
               prior = Integer.valueOf(args[0]).intValue();
               }catch (NumberFormatException ex){
               System.out.println("Invalid priority number");
               System.exit(0);
               }
               if ((prior != 1) && (prior != 2)){
                                                System.out.println("Invalid Priority number[1-prior.to Master,2 - to Slave]");
                                                System.exit(1);
                                                }
               Cliente applicazione = new Cliente(prior);
	}

	//GESTIONE CHIUSURA FINESTRA
        public class WindowHandlerCliente extends WindowAdapter{
		public void windowClosing(WindowEvent e){
                try{
                    socketSERVER.close();
                   }catch (IOException ex){
                       System.out.println("IO error closing socket");
                       System.exit(1);
                       }
                System.exit(0);
        	}
	}
	

	
	//GESTIONE DEGLI EVENTI 
        public class MenuItemHandlerCliente implements ActionListener {
                public void actionPerformed(ActionEvent e){

			String comando = e.getActionCommand();
                        if(comando.equals("Prenotazione")){
                                System.out.println("Premuto PRENOTA");
                                if (!(mandaDBAlServer())){
                                    System.out.println("Il server  caduto: Riconnettersi");
                                    System.exit(1);
                                    }
                                if (!(leggiDalServer())){
                                    System.out.println("Il server  caduto: Riconnettersi e controllare per l'ultima richiesta");
                                    System.exit(1);
                               }
                        }
			else
                        if(comando.equals("Aggiorna Situazione")){
                               System.out.println("Premuto AGGIORNA SITUAZIONE");
                         
                               // FACCIO LA RICHIESTA AL SERVER
                               if (!(mandaAlServer("Richiesta"))){
                                 System.out.println("Il Server  caduto:Riconnettersi");
                                 System.exit(1);
                                 }

                              // LEGGO DAL SERVER e AGGIORNO LA TABELLA
                              if (!(leggiDalServer())){
                                 System.out.println("Il Server  caduto :Riconnettersi");
                                 System.exit(1);
                                 }

                              }

                        else  System.out.println("Comando non riconosciuto");
		}
	}
	
	//ETICHETTE
	class Intestazione extends JPanel{
		public void paint(Graphics g){
                        g.setFont(new Font("TimesRoman",Font.BOLD+Font.ITALIC,25));
			g.setColor(Color.black);
                        g.drawString("Riccione Terme S.p.A.",190,20);
                        g.drawString("Camerino 1 - Situazione",10,50);

                }

	}
	
	class Intestazione1 extends JPanel{
		public void paint(Graphics g){
                        g.setFont(new Font("TimesRoman",Font.BOLD+Font.ITALIC,14));
			g.setColor(Color.black);
                        g.drawString("           Lunedi'             Martedi'         Mercoledi'        Giovedi'          Venerdi'           Sabato",10,20);
		}
	}

        class Intestazione2 extends JPanel{
		public void paint(Graphics g){
                        g.setFont(new Font("TimesRoman",Font.BOLD+Font.ITALIC,25));
			g.setColor(Color.black);
                        g.drawString("Camerino 1 - Prenotazione",10,20);
		}
	}


        class Intestazione3 extends JPanel{
		public void paint(Graphics g){
                        g.setFont(new Font("TimesRoman",Font.BOLD+Font.ITALIC,14));
			g.setColor(Color.black);
                        g.drawString("    Lu   Ma   Me   Gi   Ve    Sa",55,20);
		}
	}


        class IntestazioneNome extends JPanel{
		public void paint(Graphics g){
                        g.setFont(new Font("TimesRoman",Font.BOLD+Font.ITALIC,25));
			g.setColor(Color.black);
                        g.drawString("Nome",10,20);
		}
	}

        class Orari extends JPanel{
		public void paint(Graphics g){
                        g.setFont(new Font("TimesRoman",Font.BOLD+Font.ITALIC,14));
			g.setColor(Color.black);
                        g.drawString("08.00",50,15);
                        g.drawString("09.00",50,32);
                        g.drawString("10.00",50,49);
                        g.drawString("11.00",50,66);
                        g.drawString("12.00",50,83);
                        g.drawString("16.00",50,100);
                        g.drawString("17.00",50,117);
                        g.drawString("18.00",50,134);


		}
	}


        class Orari2 extends JPanel{
		public void paint(Graphics g){
                        g.setFont(new Font("TimesRoman",Font.BOLD+Font.ITALIC,14));
			g.setColor(Color.black);
                        g.drawString("08.00",50,15);
                        g.drawString("09.00",50,35);
                        g.drawString("10.00",50,55);
                        g.drawString("11.00",50,75);
                        g.drawString("12.00",50,95);
                        g.drawString("16.00",50,115);
                        g.drawString("17.00",50,135);
                        g.drawString("18.00",50,155);


		}
	}

  class ErroriHandler extends WindowAdapter implements ActionListener{

     public void windowClosing(WindowEvent e){
        Cliente.this.show();
        dialogErrore.dispose();
        }

     public void actionPerformed(ActionEvent e){
        Cliente.this.show();
        dialogErrore.dispose();
        }
 }


}




 class CalendarModel extends AbstractTableModel {
  String[][] calendar = new String[8][6];

  public CalendarModel(DB database) {
  System.out.println("Sono in CalendarModel(DB)");
   for(int i=0;i<8;++i)
    for(int j=0;j<6;++j)
     {calendar[i][j]=database.leggipren(i+1,j+1);
      System.out.print(calendar[i][j]+"*");
     }
  }

  public CalendarModel() {
   for(int i=0;i<8;++i)
    for(int j=0;j<6;++j)
     calendar[i][j]="";
  }

  public int getRowCount() {
   return 8;
  }
  public int getColumnCount() {
   return 6;
  }
  public Object getValueAt(int row, int column) {
   return calendar[row][column];
  }
  public void setValueAt(Object value,int row, int column) {
   calendar[row][column] = (String) value;
  }
}