import java.lang.System;
import java.net.DatagramSocket;
import java.net.DatagramPacket;
import java.net.SocketException;
import java.net.InetAddress;
import java.io.IOException;
import java.io.InterruptedIOException;
import java.util.Date;

/***************************************************************************
**
**  Classe Manager - CONTROLLORE DINAMICO
**
*****************************************************************************/

public class Manager {
 static private int NUMSERVER = 2;
 static InetAddress AddSERVER1; 
 static InetAddress AddSERVER2;
 static private String SERVER1;  // oemcomputer;
 static private String SERVER2;  // oemcomputer;
 static DatagramSocket socket ;
 static int intervallo = 60; //intervallo dopo cui si manda richiesta di agg. ai Server
 static int contatti   = 0;  //contatore contatti per intervallo
 static int contSERVER1 = 0;
 static int contSERVER2 = 0;
 static int numserverUP = 0;  // 0  - Nessuno
                              // 1  - Solo SERVER1 (Master)
                              // 2  - Solo SERVER2 (Slave)
                              // 12 - Sia SERVER1 che SERVER2

 public static void main(String args[]){
   String risposta="";
   boolean invio = false;  //per stabilire se devo inviare risposta al mittente
  try{
   socket = new DatagramSocket(2345);
   AddSERVER1 = InetAddress.getByName("lab2-pc02");
   AddSERVER2 = InetAddress.getByName("lab2-pc05");
   SERVER1 = AddSERVER1.getHostName().trim();
   SERVER2 = AddSERVER2.getHostName().trim();
   String localAddress = InetAddress.getLocalHost().getHostName().trim();
   int localPort = socket.getLocalPort();
   System.out.println("Manager start with address: "+ localAddress+".");
   int bufferLength = 256;
   byte outBuffer[];
   byte inBuffer[] = new byte[bufferLength];
   DatagramPacket outDatagram;
   DatagramPacket inDatagram = new DatagramPacket(inBuffer,inBuffer.length);

   // SEGNALAZIONE AL MASTER
   risposta = "start";
   outBuffer = risposta.getBytes();
   outDatagram = new DatagramPacket(outBuffer,outBuffer.length,AddSERVER1,2201);
   socket.send(outDatagram);
   System.out.println("Sent "+risposta+" to MASTER at port 2201.");

   // SEGNALAZIONE ALLO SLAVE 
   outDatagram = new DatagramPacket(outBuffer,outBuffer.length,AddSERVER2,2202);
   socket.send(outDatagram);
   System.out.println("Sent "+risposta+" to SLAVE at port 2202.");
   System.out.println("Actual State.ServerUP:"+numserverUP+" Server1: "+contSERVER1+" Server2: "+contSERVER2);
   System.out.println("Manager is already and listening on port "+localPort+".");
   boolean finished = false;
   do {
    inBuffer = new byte[bufferLength];    //Vuoto il Buffer precedente per evitare sovrapposizioni
    inDatagram = new DatagramPacket(inBuffer,inBuffer.length);
    socket.receive(inDatagram);
    InetAddress destAddress = inDatagram.getAddress();
    String destHost = destAddress.getHostName().trim();
    int destPort = inDatagram.getPort();
    System.out.println("\nReceived a datagram from "+destHost+" at port "+
     destPort+".");
    String data = new String(inDatagram.getData()).trim();
    System.out.println("It contained the data: "+data);
    if(data.equalsIgnoreCase("getconn")){
    	  contatti = contatti + 1; 
        invio = true;
        switch(numserverUP){
           case 0:
                  risposta = "NOSERVER";
                  break;
           case 1:
                  risposta = SERVER1; //+ "1";
                  contSERVER1++;
                  break;
           case 2:
                  risposta = SERVER2; //+ "2";
                  contSERVER2++;
                  break;
           case 12:
                  if (contSERVER1>contSERVER2) {
                                                contSERVER2++;
                                                risposta = SERVER2; //+"2";
                                                }
                  else{
                       contSERVER1++;
                       risposta = SERVER1; //+"1";
                      }
                  break;
            default:
                  risposta = "NACK";
           }// End Switch
       }//end if
    else if(data.equalsIgnoreCase("start")){
           invio = true;
           risposta = "OK";
             if ( (destAddress.equals(AddSERVER1)) && (destPort == 2201) ){

                   if (numserverUP == 0)  numserverUP = 1;
                    else if (numserverUP == 1)  numserverUP = 1;
                          else if (numserverUP == 2)  numserverUP = 12;
                                else if (numserverUP == 12) numserverUP = 12;
                                      else risposta = "Fatal Error";
               }

             if ( (destAddress.equals(AddSERVER2)) && (destPort == 2202) ){
                   if (numserverUP == 0)  numserverUP = 2;
                    else if (numserverUP == 1)  numserverUP = 12;
                          else if (numserverUP == 2)  numserverUP = 2;
                                else if (numserverUP == 12) numserverUP = 12;
                                      else risposta = "Manager:Fatal Error";
               }

        }


        
    else if(data.startsWith("OKMASTER")){

           invio = false;
           data = data.substring(8);

           // AGGIORNO IL NUMERO DI CLIENTI CHE IL MASTER STA SERVENDO
           if (Utility.testNum(data))
                 contSERVER1 =  Utility.StringtoInt(data);
           else  System.out.println("Letto un numero incomprensibile di Client dal Master");

           // CONTROLLO SE ERA GIA' SEGNATO PER RIAVVIO CONTEMP.
           if (numserverUP == 0) numserverUP = 1;
             else if (numserverUP == 2) numserverUP = 12;

           // NON INVIO NULLA A NESSUNO

           }

    else if(data.startsWith("OKSLAVE")){

           invio = false;
           data = data.substring(7);

           // AGGIORNO IL NUMERO DI CLIENTI CHE LO SLAVE STA SERVENDO
           if (Utility.testNum(data))
                 contSERVER2 =  Utility.StringtoInt(data);
           else  System.out.println("Letto un numero incomprensibile di Client dallo Slave");

           // CONTROLLO SE ERA GIA' SEGNATO PER RIAVVIO CONTEMP.

           if (numserverUP == 0) numserverUP = 2;
             else if (numserverUP == 1) numserverUP = 12;
           // NON INVIO NULLA A NESSUNO

           }

    else if(data.equalsIgnoreCase("MASTER DOWN")){
            invio = false;

           // RIAZZERO IL NUMERO DI CLIENT SERVITI DAL MASTER
            contSERVER1 = 0;

           // CONTROLLO SE ERA SEGNATO
            if (numserverUP == 1) numserverUP = 0;
              else if (numserverUP == 12) numserverUP = 2;

           // NON INVIO NULLA A NESSUNO

           }

    else if(data.equalsIgnoreCase("SLAVE DOWN")){
            invio = false;

           // RIAZZERO IL NUMERO DI CLIENT SERVITI DALLO  SLAVE
            contSERVER2 = 0;

           // CONTROLLO SE ERA SEGNATO 
            if (numserverUP == 2) numserverUP = 0;
              else if (numserverUP == 12) numserverUP = 1;

           // NON INVIO NULLA A NESSUNO

           }

    else if(data.equalsIgnoreCase("CLIENT DOWN")){
            invio = false;

           if ( (destAddress.equals(AddSERVER1)) && (destPort == 2201) && (contSERVER1>0) )
           																		contSERVER1 = contSERVER1 - 1;

           else if ( (destAddress.equals(AddSERVER2)) && (destPort == 2202)  && (contSERVER2>0) )
                                             contSERVER2 = contSERVER2 - 1;
          }
    if(invio == true)
    {
       outBuffer=risposta.getBytes();
       outDatagram = new DatagramPacket(outBuffer,outBuffer.length,destAddress,destPort);
       socket.send(outDatagram);
       System.out.println("Sent "+risposta+" to "+destHost+" at port "+destPort+".");
     }
   System.out.println("Actual State.ServerUP: "+numserverUP+" Server1: "+contSERVER1+" Server2: "+contSERVER2+" Cont: "+contatti);
   if (contatti>intervallo){
   	   contatti = 0;
   		// SEGNALAZIONE AL MASTER
   		risposta = "start";
   		outBuffer = risposta.getBytes();
   		outDatagram = new DatagramPacket(outBuffer,outBuffer.length,AddSERVER1,2201);
   		socket.send(outDatagram);
   		System.out.println("Sent "+risposta+" to MASTER per allineamento");

   		// SEGNALAZIONE ALLO SLAVE 
   		outDatagram = new DatagramPacket(outBuffer,outBuffer.length,AddSERVER2,2202);
   		socket.send(outDatagram);
   		System.out.println("Sent "+risposta+" to SLAVE per allineamento");
   		System.out.println("Actual State.ServerUP:"+numserverUP+" Server1: "+contSERVER1+" Server2: "+contSERVER2);
   }
   	
   } while(!finished);
  }catch (IOException ex){
   System.out.println("IOException occurred.");
  }
 }
}