import java.lang.System;
import java.net.ServerSocket;
import java.net.Socket;
import java.io.*;
import java.net.SocketException;
import java.net.InetAddress;  
import java.io.InterruptedIOException;
import java.net.UnknownHostException;
import java.io.IOException;

import java.net.DatagramSocket;
import java.net.DatagramPacket;


/****************************************************************************
**
**       class SERVER1 - SERVER MASTER
**       ASCOLTA:
**       CLIENT  SU PORTA   54
**       SLAVE   SU PORTA 2301
**       MANAGER SU PORTA 2201
**
*****************************************************************************/

public class Server1 {
static DB camerino1;
static boolean unicoserver;              // TRUE   - LAVORO DA SOLO
                                         // FALSE  - DEVO COORDINARMI CON SERVER SLAVE
static Socket      socketSERVER;         // SOCKET PER OUTPUT SU SLAVE 
static int         portaSERVER = 2302;   // PORTA SU CUI SLAVE RICEVE
                                         // SERVER1 - MASTER: 2301
                                         // SERVER2 - SLAVE : 2302
static InetAddress ipSERVER;             // INDIRIZZO IP SLAVE
static ObjectOutputStream STREAMInvio;
static ObjectInputStream  STREAMRicez;
static ServertoManager StoM;
static int numClientAccepted = 0; //Numero di Clienti che si stanno servendo

 public static void main(String args[]) throws ClassNotFoundException{
   
   try{
   camerino1 = new DB();
   camerino1.inseriscipren(1,1,"Gianluca Tonti");
   camerino1.inseriscipren(2,1,"Antonio Corradi");
   camerino1.inseriscipren(4,4,"Pinco Pallino");
   unicoserver = true;

   // CREO UN THREAD DI ASCOLTO
      ServertoServer StoS = new ServertoServer();

   // SEGNALAZIONE AL MANAGER
      StoM = new ServertoManager();

   // PROVO A CONNETTERMI PER INVIO
   try{
   InetAddress localAddress = InetAddress.getLocalHost();
    try{
        //TENTATIVO DI CONNESSIONE ALLO SLAVE
      if (ConnToSlave()){
           Server1.unicoserver = false;
              // INVIO AL MASTER DI Start
           STREAMInvio.writeObject("Start");
           STREAMInvio.flush();
           System.out.println("Server1:Inviato 'Start' allo Slave");
           Object risposta = STREAMRicez.readObject();
           boolean OKLetto = false;
           do{
           //AGGIORNO IL DB CAMERINO1
           if (risposta instanceof DB){
                 synchronized(Server1.camerino1){
                 OKLetto  = true;
                 DB DBpren = (DB) risposta;
                 String nomeappoggio;

                 for(int i=0;i<8;++i)
                        for(int j=0;j<6;++j){
                               nomeappoggio = DBpren.leggipren(i+1,j+1);
                               (Server1.camerino1).inseriscipren(i+1,j+1,nomeappoggio);
                                }// chiudo for
                  }//chiudo sync
                }//chiudo if
            else{
                 System.out.println("Server1:Letto Oggetto non di protocollo da SLAVE: "+risposta);
                 }
           }while(!(OKLetto));
          System.out.println("Server1:Situazione aggiornata: "+Server1.camerino1);

      }//FINE IF
    }catch (IOException ex){
      System.out.println("Server1: IO Exception in invio 'Start'");
      Server1.unicoserver = true;
      socketSERVER.close();
     }

   }catch (UnknownHostException ex){
      System.out.println("Unknown host");
      System.exit(1);
      }




   // CONNESSIONE CON I CLIENT
   ServerSocket server = new ServerSocket(54);
   int localPort = server.getLocalPort();
   System.out.println("Server1 is already and listening for Client on port "+localPort+".");
   boolean finished = false;
   do {

   Socket client = server.accept();
   numClientAccepted = numClientAccepted + 1;
   System.out.println("SERVER1:Cliente accettato apro il Thread ServerConnesssione per servirlo.");
   ServerConnessione connection = new ServerConnessione(client);
   } while(!finished);
    }catch (IOException ex){
   System.out.println("IOException occurred.");
   System.exit(1);//NON DEVO CAPITARE QUI!
     }

 }


// PER CONNETTERSI (O PROVARE) CON L'ALTRO SERVER
// TRUE : ALTRO SERVER UP  -  FALSE : DOWN
static boolean ConnToSlave(){

    try{
      ipSERVER = InetAddress.getByName("lab2-pc05");  
      System.out.println("Server1:Provo a connettermi con "+ipSERVER);
      socketSERVER = new Socket(ipSERVER,portaSERVER);
      System.out.println("Server1:Connected to: "+ipSERVER+" on port: "+portaSERVER);
      STREAMInvio = new ObjectOutputStream(socketSERVER.getOutputStream());
      STREAMRicez = new ObjectInputStream(socketSERVER.getInputStream());
    }catch (IOException ex){
      System.out.println("Server1:Lo Slave non risponde");
      Server1.unicoserver = true;
      return false;
     }
     return true;
   }


}
