import java.lang.System;
import java.net.ServerSocket;
import java.net.Socket;
import java.io.*;
import java.net.SocketException;
import java.net.InetAddress;
import java.io.InterruptedIOException;
import java.net.UnknownHostException;
import java.io.IOException;

/****************************************************************************
**
**       class SERVER2 - SERVER SLAVE
**       ASCOLTA
**       CLIENT  SU PORTA   542
**       MASTER  SU PORTA  2302
**       MANAGER SU PORTA  2202
**
*****************************************************************************/

public class Server2 {
static DB camerino1;
static boolean unicoserver;              // TRUE   - LAVORO DA SOLO
                                         // FALSE  - DEVO COORDINARMI CON SERVER SLAVE
static Socket      socketSERVER;         // SOCKET PER OUTPUT SU SLAVE 
static int         portaSERVER = 2301;   // PORTA SU CUI SLAVE RICEVE
                                         // SERVER1 - MASTER: 2301
                                         // SERVER2 - SLAVE : 2302
static InetAddress ipSERVER;             // INDIRIZZO IP SLAVE
static ObjectOutputStream STREAMUscita;
static ObjectInputStream  STREAMIngres;
static ServertoManager2 StoM;
static int numClientAccepted = 0; //Numero di Clienti che si stanno servendo

 public static void main(String args[]) throws ClassNotFoundException{
   
   try{
   camerino1 = new DB();
   camerino1.inseriscipren(1,1,"Gianluca Tonti");
   camerino1.inseriscipren(2,1,"Antonio Corradi");
   unicoserver = true;


   // CREO UN THREAD DI ASCOLTO
      ServertoServer2 STOS = new ServertoServer2();   

   // SEGNALAZIONE AL MANAGER
      StoM = new ServertoManager2();


   // PROVO A CONNETTERMI PER INVIO
   try{
   InetAddress localAddress = InetAddress.getLocalHost();
    try{
        //TENTATIVO DI CONNESSIONE AL MASTER
      if (ConnToMaster()){
           Server2.unicoserver = false;
              // INVIO AL MASTER DI Start
           STREAMUscita.writeObject("Start");
           STREAMUscita.flush();
           System.out.println("Server2:Inviato 'Start' al Master");
           STREAMIngres = new ObjectInputStream(socketSERVER.getInputStream());
           Object risposta = STREAMIngres.readObject();
           System.out.println("Server2:Letto: "+risposta);

           boolean OKLetto = false;
           do{
           //AGGIORNO IL DB CAMERINO1
           if (risposta instanceof DB){
                 DB DBpren = (DB) risposta;
                 String nomeappoggio;

                 synchronized(camerino1){
                       OKLetto  = true;
                       for(int i=0;i<8;++i)
                                for(int j=0;j<6;++j){
                                        nomeappoggio = DBpren.leggipren(i+1,j+1);
                                        (camerino1).inseriscipren(i+1,j+1,nomeappoggio);
                                }// chiudo for
                  }//chiudo sync
                }//chiudo if
            else{
                 System.out.println("Server2:Letto Oggetto non di protocollo da SLAVE: "+risposta);
                 }
           }while(!(OKLetto));

           System.out.println("Server2:Situazione aggiornata ricevuta dal Master: "+Server2.camerino1);

      }//FINE IF
    }catch (IOException ex){
      System.out.println("Server2: IO Exception in invio 'Start'");
      Server2.unicoserver = true;
      socketSERVER.close();
     }

   }catch (UnknownHostException ex){
      System.out.println("Server2:Unknown host");
      System.exit(1);
      }


   // CONNESSIONE CON I CLIENT
   ServerSocket server = new ServerSocket(542);
   int localPort = server.getLocalPort();
   System.out.println("Server2 is already and listening on port "+localPort+".");
   boolean finished = false;
   do {

   Socket client = server.accept();
   numClientAccepted = numClientAccepted + 1;
   System.out.println("Server2:Cliente Accettato.Apro il Thread ServerConnessione2 per servirlo.");
   ServerConnessione2 connection = new ServerConnessione2(client);
   } while(!finished);
    }catch (IOException ex){
   System.out.println("Server2:IOException occurred.");
   System.exit(1);//NON DEVO CAPITARE QUI!
     }

 }

static boolean ConnToMaster(){

    try{
      ipSERVER = InetAddress.getByName("lab2-pc02");
      System.out.println("Server2:Provo a connettermi con "+ipSERVER);
      socketSERVER = new Socket(ipSERVER,portaSERVER);
      System.out.println("Server2:Connected to "+ipSERVER+" on port: "+portaSERVER);
      STREAMUscita = new ObjectOutputStream(socketSERVER.getOutputStream());
    }catch (IOException ex){
      System.out.println("IO error creating socket in Server2");
      System.out.println("Server2:Il Master non risponde");
      Server2.unicoserver = true;
      return false;
     }
     return true;
   }


}





