import java.lang.System;
import java.net.ServerSocket;
import java.net.Socket;
import java.io.*;

/***************************************************************************
**
**       class ServerConnessione - thread che implementa una singola connes-
**        sione del Server Master con un Client
**
***************************************************************************/

class ServerConnessione implements Runnable{
Socket Client;
ObjectInputStream inStream;
ObjectOutputStream outStream;
Thread t;

ServerConnessione(Socket sock){
Client=sock;
t = new Thread(this);
System.out.println("Un Thread ServerConnessione si  attivato per connessione con un Client");
t.start();
}

public void run(){
    try{
     try{
    outStream = new ObjectOutputStream(Client.getOutputStream());
    ObjectInputStream inStream = new ObjectInputStream(Client.getInputStream());
    String destName = Client.getInetAddress().getHostName();
    int destPort = Client.getPort();
    System.out.println("ServerConnessione:Accepted connection from "+destName+" on port "+destPort+".");

    boolean finished = false;
    do {

    System.out.println("ServerConnessione:Waiting for request...");
    Object inLine = inStream.readObject();
  

   if (inLine instanceof String){
         if(((String) inLine).equalsIgnoreCase("Richiesta")){
                 System.out.println("ServerConnessione:Ricevuta RICHIESTA da un Client");
                 DB APPOGGIO = DB.creacopia(Server1.camerino1);
                 outStream.writeObject(APPOGGIO);
                 outStream.flush();
                 System.out.println("ServerConnessione.Sent to CLient: "+APPOGGIO);
                 }
         if(((String) inLine).equalsIgnoreCase("Quit")) finished = true; 
         }
    else
       if (inLine instanceof DB)
         { // CASO CHE LEGGA UNA TABELLA
         System.out.println("ServerConnessione:Ricevuta una Tabella di pren. da un Client: "+inLine);

          // AGGIORNA LA TABELLA LOCALE
          AggiornaTabella((DB) inLine);
         }
     else
         { // CASO CHE LEGGO OGGETTO NON IDENTIFICATO
          outStream.writeObject("ServerConnessione:Attenzione! Letto oggetto sconosciuto da un Client- Riprova!");
          outStream.flush();
         }

   }while(!finished);
     }catch (ClassNotFoundException cnfe){
      System.out.println("ClassNotFoundException occurred in thread ServerConnessione.");
      }

   }catch (IOException ex){
      System.out.println("IOException occurred in thread ServerConnessione.");
      shutdown();
      }

   

}

      // AGGIORNAMENTO DELLA TABELLA - TRASMISSIONE ALL'ALTRO SERVER
      // INVIO RISPOSTA AL CLIENT
      public void AggiornaTabella(DB DBpren) throws ClassNotFoundException{

          String nomeappoggio;
          String Message = "";
          boolean possibilepren = true;

          // LEGGO DUE VOLTE LA TABELLA: 1 - CONTROLLO POSSIBILITA'
          //                             2 - ESEGUO  PRENOTAZIONE
          try{
          // 1 - CONTROLLO POSSIBILITA'
            synchronized(Server1.camerino1){
             for(int i=0;i<8;++i)
              for(int j=0;j<6;++j){
               nomeappoggio = DBpren.leggipren(i+1,j+1);
                if (!(nomeappoggio.equals("")))
                        if (!((Server1.camerino1).leggipren(i+1,j+1)).equals("")){
                           Message = "ERRORE!! Fascia "+DB.convertigiorno(j+1)+"-"+DB.convertiora(i+1)+" gia' prenotata. CONTROLLA!";
                           System.out.println(Message);
                           possibilepren=false;
                           }
                }//chiudo for

          // 2 - ESEGUO  PRENOTAZIONE
           if (possibilepren){
            for(int i=0;i<8;++i)
             for(int j=0;j<6;++j){
                nomeappoggio = DBpren.leggipren(i+1,j+1);
                if (!(nomeappoggio.equals("")))
                        if (((Server1.camerino1).leggipren(i+1,j+1)).equals(""))
                                           (Server1.camerino1).inseriscipren(i+1,j+1,nomeappoggio);
                        else {
                              System.out.println("Errore.Fascia "+i+","+j+"gia' prenotata.");
                              possibilepren = false;
                             }
             }// chiudo for
           }//chiudo if
          }//chiudo sync
          System.out.println("ServerConnessione:Situazione aggiornata: "+Server1.camerino1);
          // MANDA LA TABELLA ALL'ALTRO SERVER
          try{
          if (possibilepren){
              if (!(Server1.unicoserver)){
                         DB Copia = DB.creacopia(DBpren);
                         // MI COORDINO CON SLAVE
                        System.out.println("ServerConnessione:Mando la tabella di  pren. allo Slave"); 
                        Server1.STREAMInvio.writeObject(Copia);
                        Server1.STREAMInvio.flush();

                         Object risposta;
                        risposta = Server1.STREAMRicez.readObject();

                        if (risposta instanceof String)
                           if (((String) risposta).equalsIgnoreCase("OK")){
                              possibilepren = true;
                              System.out.println("ServerConnessione:Ho ricevuto OK dallo Slave");
                              }
                           else { // RICEVUTO MESSAGGIO:TABELLE FATALMENTE DISALLINEATE
                                 possibilepren = false;
                                 Message = (String) risposta + " CONTATTARE IL PROGRAMMATORE!";
                                 }
                        else {
                              System.out.println("ServerConnessione:Oggetto non di protocollo ricevuto dallo Slave");
                              System.exit(1);
                             }

                              
                        }//FINE IF Server1.unicoserver
              }//FINE IF possibilepren
          }catch(IOException IOex){
            System.out.println("ServerConnessione:Server SLAVE caduto!");
            Server1.unicoserver = true;
            Server1.StoM.invioalManager("SLAVE DOWN");
           }

          // RISPONDI AL CLIENT CON LA TABELLA AGGIORNATA O RISPOSTA NEGATIVA
             if (possibilepren){
                 System.out.println("ServerConnessione:Invio al Client la tabella aggiornata"); 
                 outStream.writeObject(DB.creacopia(Server1.camerino1));
                 outStream.flush();
                 }
             else {
                 System.out.println("ServerConnessione:Invio al Client il Messaggio"+Message); 
                 outStream.writeObject(Message);
                 outStream.flush();
                 }
       }catch (IOException ex){
          System.out.println("ServerConnessione:Un Client ha terminato");
          shutdown();
         }


         }

      // CHIUSURA DELLA CONNESSIONE
      public void shutdown(){
      try{

       // CHIUDO LA CONNESSIONE
       Client.close();

       // INVIO MESSAGGIO AL MANAGER
       Server1.StoM.invioalManager("CLIENT DOWN");

       //DECREMENTO IL NUMERO DI CLIENT IN ESECUZIONE
       Server1.numClientAccepted = Server1.numClientAccepted - 1; 

       }catch (IOException ex2){
          System.out.println("IO error closing socket in Thread ServerConnessione");
          System.exit(1);
          }
      }


}


