import java.lang.System;
import java.net.ServerSocket;
import java.net.Socket;
import java.io.*;

/***************************************************************************
**
**       class ServerConnessione - thread che implementa una singola connes-
**        sione del Server Slave con un Client
**
***************************************************************************/

class ServerConnessione2 implements Runnable{
Socket Client;
ObjectInputStream inStream;
ObjectOutputStream outStream;
Thread t;

ServerConnessione2(Socket sock){
Client=sock;
t = new Thread(this);
System.out.println("Attivo ServerConnessione2");
t.start();
}

public void run(){
    try{
     try{
    outStream = new ObjectOutputStream(Client.getOutputStream());
    ObjectInputStream inStream = new ObjectInputStream(Client.getInputStream());
    String destName = Client.getInetAddress().getHostName();
    int destPort = Client.getPort();
    System.out.println("ServerConnessione2:Accepted connection from "+destName+" on port "+destPort+".");

    boolean finished = false;
    do {

    System.out.println("ServerConnessione2:Waiting for request...");
    Object inLine = inStream.readObject();
  

   if (inLine instanceof String){
         if(((String) inLine).equalsIgnoreCase("Richiesta")){
                 System.out.println("ServerConnessione2:Ricevuta RICHIESTA da un Client");
                 DB APPOGGIO = DB.creacopia(Server2.camerino1);
                 outStream.writeObject(APPOGGIO);
                 outStream.flush();
                 System.out.println("ServerConnessione2.Inviato al CLient: "+APPOGGIO);
                 }
         if(((String) inLine).equalsIgnoreCase("Quit")) finished = true; 
         }
    else
       if (inLine instanceof DB)
         { // CASO CHE LEGGA UNA TABELLA
         System.out.println("ServerConnessione2:Ricevuta tabella per pren. da un Client "+inLine);

          // AGGIORNA LA TABELLA LOCALE
          AggiornaTabella((DB) inLine);
         }
     else
         { // CASO CHE LEGGO OGGETTO NON IDENTIFICATO
          outStream.writeObject("ServerConnessione2:Attenzione! Letto oggetto sconosciuto da un Client- Riprova!");
          outStream.flush();
         }

   }while(!finished);
     }catch (ClassNotFoundException cnfe){
      System.out.println("ClassNotFoundException occurred in thread ServerConnessione2.");
      }

   }catch (IOException ex){
      System.out.println("IOException occurred in thread ServerConnessione2.");
      shutdown();
      }

   

}
      // 1 - CONTROLLO LOCALE
      // 2 - TRASMISSIONE ALL'ALTRO SERVER (MASTER)
      // 3 - RICEZIONE ASSENSO O DISSENSO
      // 4 - AGGIORNAMENTO TABELLA LOCALE
      // 5 - INVIO RISPOSTA AL CLIENT
      public void AggiornaTabella(DB DBpren) throws ClassNotFoundException{

          String nomeappoggio;
          String Message = "";
          boolean possibilepren = true;

          // 1 - CONTROLLO LOCALE
          try{
           // LEGGO LA TABELLA: CONTROLLO POSSIBILITA'
            synchronized(Server2.camerino1){
             for(int i=0;i<8;++i)
              for(int j=0;j<6;++j){
               nomeappoggio = DBpren.leggipren(i+1,j+1);
                if (!(nomeappoggio.equals("")))
                        if (!((Server2.camerino1).leggipren(i+1,j+1)).equals("")){
                           Message = "ERRORE!! Fascia "+DB.convertigiorno(j+1)+"-"+DB.convertiora(i+1)+" gia' prenotata. CONTROLLA!";
                           System.out.println(Message);
                           possibilepren=false;
                           }
                }//chiudo for
          }//chiudo sync
          if (possibilepren){

             // 2 - TRASMISSIONE ALL'ALTRO SERVER (MASTER)
            try{
              if (!(Server2.unicoserver)){
                          DB Copia = DB.creacopia(DBpren);
                          // MI COORDINO CON MASTER
                          System.out.println("ServerConnessione2:Invio copia di tabella pren. al Master"); 
                          Server2.STREAMUscita.writeObject(Copia);
                          Server2.STREAMUscita.flush();
                          Object risposta;

                          // 3 - RICEZIONE ASSENSO O DISSENSO

                          risposta = Server2.STREAMIngres.readObject();
                          if (risposta instanceof String)
                            if (((String) risposta).equalsIgnoreCase("OK"))
                              System.out.println("ServerConnessione2:Ricevuto OK dal Master");
                           else {
                                 // TRANSAZIONE NON A BUON FINE.PUBBLICO IL MOTIVO
                                 possibilepren=false;
                                 Message = (String) risposta;
                                 }
                        else {
                              System.out.println("ServerConnessione2:Oggetto dal MAster non di protocollo");
                              System.exit(1);
                             }
                        }//FINE IF  RISPOSTA

            }catch(IOException IOex){
               System.out.println("ServerConnessione2:Server MASTER caduto!");
               Server2.unicoserver = true;
               Server2.StoM.invioalManager("MASTER DOWN");
               }
          // SE ALTRO DOWN MANDA AL MANAGER

         }//FINE IF POSSIBILEPRE

           // 4 - AGGIORNAMENTO TABELLA LOCALE
           if (possibilepren){
           synchronized(Server2.camerino1){
            for(int i=0;i<8;++i)
             for(int j=0;j<6;++j){
                nomeappoggio = DBpren.leggipren(i+1,j+1);
                if (!(nomeappoggio.equals("")))
                        if (((Server2.camerino1).leggipren(i+1,j+1)).equals(""))
                                           (Server2.camerino1).inseriscipren(i+1,j+1,nomeappoggio);
                        else {
                              System.out.println("Errore.Fascia "+i+","+j+"gia' prenotata.");
                              possibilepren = false;
                             }
             }// chiudo for
            }// chiudo sync
           }//chiudo if
          System.out.println("ServerConnessione2:Situazione aggiornata: "+Server2.camerino1);

           // 5 - INVIO RISPOSTA AL CLIENT

             if (possibilepren){
                 System.out.println("ServerConnessione2:Inviata al Client situazione aggiornata");
                 outStream.writeObject(DB.creacopia(Server2.camerino1));
                 outStream.flush();
                 }
             else {
                 System.out.println("ServerConnessione2:Inviata al Client Messaggio "+Message);
                 outStream.writeObject(Message);
                 outStream.flush();
                 }
       }catch (IOException ex){
          System.out.println("ServerConnessione2: UN Client ha terminato.");
          shutdown();
         }


         }

      // CHIUSURA DELLA CONNESSIONE
      public void shutdown(){
      try{

       //CHIUDO LA CONNESSIONE
       Client.close();

       //INVIO MESSAGGIO AL MANAGER
       Server2.StoM.invioalManager("CLIENT DOWN");

       //DECREMENTO IL NUMERO DI CLIENT IN ESECUZIONE
       Server2.numClientAccepted = Server2.numClientAccepted - 1; 

       }catch (IOException ex2){
          System.out.println("IO error closing socket in Thread ServerConnessione2");
          System.exit(1);
          }
      }


}


